using FCOMMON;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace FPJ0000
{
    public partial class Import : fBase
    {
        DataTable dt = new dsPRJ.ProjectsDataTable();
        DataTable dtExcel = new DataTable();
        public Import()
        {
            InitializeComponent();
            this.FormClosed += __Closed;
        }

        private void __Load(object sender, EventArgs e)
        {
            EnsureVisibleAndUsableSize();
        }

        void __Closed(object sender, FormClosedEventArgs e)
        {
          
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            OpenFileDialog od = new OpenFileDialog();
            od.Filter = "excel|*.xlsx|all files|*.*";
            od.InitialDirectory = FCOMMON.Util.CurrentPath + "model";
            od.FilterIndex = 1;
            od.RestoreDirectory = true;
            if (od.ShowDialog() != System.Windows.Forms.DialogResult.OK) return;
            textBox1.Text = od.FileName;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int ColumnNameNo = (int)numericUpDown2.Value;
            if(textBox1.Text == "")
            {
                FCOMMON.Util.MsgE("파일을 선택하세요");
                textBox1.Focus();
                return;
            }
            if(!System.IO.File.Exists(textBox1.Text))
            {
                FCOMMON.Util.MsgE("입력하신 파일이 존재하지 않습니다.");
                textBox1.Focus();
                textBox1.SelectAll();
                return;
            }

            dtExcel.Columns.Clear();
            dtExcel.Rows.Clear();
            dtExcel.AcceptChanges();
            
            libxl.Book book;// = new libxl.BinBook();
            book = new libxl.XmlBook();
            book.setKey(FCOMMON.info.libxlCompany, FCOMMON.info.libxlKey);
            try
            {
                book.load(textBox1.Text);
            }catch (Exception ex)
            {
                FCOMMON.Util.MsgE(ex.Message);
                return;
            }
          
            var sheet = book.getSheet((int)nudSheet.Value-1);
            var MaxRow = sheet.lastRow();            
            var MinRow = sheet.firstRow();

            MaxRow = (int)Math.Min(MaxRow, nudE.Value-1);
            MinRow = (int)Math.Max(MinRow, nudS.Value-1);
            if(MinRow <= (ColumnNameNo-1))
            {
                FCOMMON.Util.MsgI("시작줄을 제목줄 보다 커야 합니다. 자동으로 +1 증가합니다.");
                MinRow = ColumnNameNo ;
            }


            var MaxCol = sheet.lastCol();
            var MinCol = sheet.firstCol();

            MaxCol = (int)Math.Min(MaxCol, nudCE.Value - 1);
            MinCol = (int)Math.Max(MinCol, nudCS.Value - 1);

            //제목줄을 처리한다.  181029
            List<string> cols = new List<string>();

            for (int c = MinCol; c <= MaxCol; c++)
            {
                var strVallue = sheet.readStr(ColumnNameNo-1, c);
                if (strVallue == "" )
                {
                    if (c == MinCol)
                    {
                        //첫줄 첫행이 빈값이면 처리하지 않는다.
                        FCOMMON.Util.MsgE("열 제목에 빈값이 있어 처리되지 못합니다.");
                        return;
                    }
                    else
                    {
                        //빈값이 나왓으므로 열 최대값을 변경해준다.
                        if(c < MaxCol)
                        {
                            FCOMMON.Util.MsgI("빈값으로 인해 최대 열 번호를 " + c.ToString() + "로 변경합니다");
                            MaxCol = c;
                            break;
                        }
                    }
                }
                if(cols.IndexOf(strVallue) >= 0)
                {
                    FCOMMON.Util.MsgE("동일 컬럼이 발견 됨 진행 불가 : " + strVallue);
                    return;
                }
                else
                {
                    cols.Add(strVallue);
                }
                
                this.dtExcel.Columns.Add(strVallue);
            }


            try{
                for (int r = MinRow; r <= MaxRow; r++)
                {
                    DataRow dr =  dtExcel.NewRow();

                    Boolean nullColumn = false;
                    for (int c = MinCol; c <= Math.Min(cols.Count,MaxCol); c++)
                    {
                        if (sheet.isDate(r, c))
                        {
                            var datevalue = sheet.readNum(r, c);
                            int y, m, d;
                            y = m = d = 0;
                            book.dateUnpack(datevalue, ref y, ref m, ref d);
                            if (y >= 2000)
                                dr[cols[c]] = string.Format("{0:0000}-{1:00}-{2:00}", y, m, d);
                            else
                                dr[cols[c]] = string.Empty;
                            
                            //일자가 만약 넘어서면 패스한다.
                            if(cols[c]=="일자" )
                            {
                                string value = dr[cols[c]].ToString();
                                if(value == "")
                                {
                                    nullColumn = true;  //날짜가 없다면 패스
                                    break;
                                } 
                            }
                        }
                        else
                        {
                            var dateStrin = sheet.readStr(r, c);

                            var strVallue = sheet.readStr(r, c);
                            if (strVallue=="" && c == MinCol)
                            {
                                //첫줄 첫행이 빈값이면 처리하지 않는다.
                                nullColumn = true;
                                break;
                            }
                            if (cols[c-1] != "")
                                dr[cols[c-1]] = strVallue;
                        }
                    }
                    if (nullColumn) continue; //줄처리를 못한 경우 넘어감
                    if (dr != null)
                    {
                        dtExcel.Rows.Add(dr);
                    }
                }
                dtExcel.AcceptChanges();
            }
           catch(Exception ex)
            {
                FCOMMON.Util.MsgE("불러오는 중 오류 발생\n" + ex.Message);
            }
            //
            book = null;

            this.bs.DataSource = dtExcel;
            this.dataGridView1.DataSource = dtExcel;
            this.bn.BindingSource = this.bs;

            if(this.bs.Count < 1)
            {
                FCOMMON.Util.MsgE("입력된 자료가 없습니다.\n\n지정된 엑셀의 1번째 칸에 값이 없다면 입력되지 않습니다.");
            }
        }


        private void button3_Click(object sender, EventArgs e)
        {
            if(dtExcel == null || dtExcel.Rows.Count < 1)
            {
                FCOMMON.Util.MsgE("등록 가능한 자료가 없습니다.");
                return;
            }

            System.Text.StringBuilder sb = new StringBuilder();
            sb.AppendLine("다음 자료를 추가하시겠습니까?");
            sb.AppendLine();
            sb.AppendLine("'저장 완료' 메세지가 나올때 까지 기다려 주세요.");
            sb.AppendLine();
            sb.AppendLine("실행 하려면 '예' 를 누르세요");
            var dlg = FCOMMON.Util.MsgQ(sb.ToString());
            if (dlg != System.Windows.Forms.DialogResult.Yes) return;
            
            dt.Clear();
            dt.AcceptChanges();

            this.progressBar1.Value = 0;
            this.progressBar1.Maximum = dtExcel.Rows.Count;

            //12,13
            foreach (DataRow dr in dtExcel.Rows)
            {
                this.progressBar1.Value += 1;

                //데이터추가
                var newdr = dt.NewRow();
                if (dr[0] == DBNull.Value) continue;   //nullerror

                newdr["level"] = 1;
                newdr["status"] = dr[0].ToString();
                newdr["part"] = dr[1].ToString();
                newdr["process"] = dr[2].ToString();
                newdr["reqstaff"] = dr[3].ToString();
                newdr["usermanager"] = dr[4].ToString();
                newdr["usermain"] = dr[5].ToString();
                newdr["usermain"] = dr[6].ToString();
                newdr["memo"] = dr[7].ToString();   //CR / Order / PO No.
                newdr["asset"] = dr[8].ToString();
                newdr["name"] = dr[9].ToString();

                if (newdr["name"].ToString() == "") continue;   //이름없는것은 처리 안함

                newdr["remark_req"] = dr[10].ToString();
                newdr["remark_ans"] = dr[11].ToString();
                //12=request date                
                newdr["sdate"] = dr[13].ToString();
                newdr["ddate"] = dr[14].ToString();
                newdr["edate"] = dr[15].ToString();

                //float value_progress = 0;
                //if (Single.TryParse(dr[12-1].ToString(), out value_progress))
                //    newdr["progress"] = value_progress;
                

                string 대수 =dr[16].ToString().Replace("대","").Replace("수","");
                if (대수 == "") 대수 = "0";

                newdr["cnt"] = int.Parse(대수);

                string sCostO = dr[17].ToString();
                string sCostN = dr[18].ToString();
                if (sCostO == "") sCostO = "0";
                if (sCostN == "") sCostN = "0";

                float value_costo = 0;
                float value_costn = 0;
                if(float.TryParse(sCostO,out value_costo))
                    newdr["costo"] = value_costo;
                if(float.TryParse(sCostO,out value_costn))
                    newdr["costn"] = value_costn;
                
                newdr["import"] = true;
                newdr["wuid"] = FCOMMON.info.Login.no;
                newdr["wdate"] = DateTime.Now;  

               dt.Rows.Add(newdr);
            }

            var taE = new dsPRJTableAdapters.ProjectsTableAdapter();
            if(checkBox1.Checked) taE.DeleteImport(FCOMMON.info.Login.gcode);
            taE.Update((dsPRJ.ProjectsDataTable)dt);

            dt.AcceptChanges();
            FCOMMON.Util.MsgI("Save OK");
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
         

        }
    }
}
